        PAGE    60,132
NAME    Espan
        TITLE   Espan.com version 2.2 1996 October 25
COMMENT 

Precis:

Espan.Com remaps your AT keyboard to the traditional Spanish
layout.  The KEYB SP program Microsoft provides a different
layout, used only on old dumb terminals.  Espan is a TSR that
takes 1088 bytes of RAM.  MASM source is provided for you to
create variants or so you can roll your own TSRs to swap or
rearrange selected keys for other languages.  ESPAN is based
on DVORAK.Com.

ESPAN is also a generic driver toolkit.  By modifying ESPAN's
tables you can rearrange keys, invent dead accent keys, generate
symbols not on the keyboard, or change the symbols you would
normally get with Shift+key.  MASM/OPTASM source provided.
Takes 1088 bytes.  Does not cheat.  Uses only legitimate BIOS
int 15 and 16 functions.

If you wish to modify this program, probably you can get the
effect you want just by changing the KEY table definitions
marked like this: <><><><><><><><><><><><><><><><><>

If you are using non-USA code pages, you might also need to change
the tables labelled: Unaccented, Spanish, Aigu, Grave, Trema,
Circ and Ring.  You may also need to disable or enable some of
the commented out code.  If you need to support the Alt-Gr key,
then QUEBEC.COM would be a better base.

The code is well commented and serves as a teaching example on
keyboard TSRs.  Limitations: AT only, no XT, unless you use KEYB
in addition.  Requires AT-style INT 15 multiplex BIOS interrupt
support.  No hot key Ctrl-Alt-F2 enable/disable.  No safety code
to prevent loading twice.

Copyrighted, but may be freely copied for non-military use only.


This program may be freely copied and used for any purpose
except military.

Usage:

insert this command near the end of your autoexec.bat file:

Espan.Com

It will translate your keyboard to Spanish layout.  Note it only
works on AT computers.

NOTE: There is no way to get rid of Espan except by rebooting.
However, if you load it in a DESQview window, you can get rid of
it my closing the window.  There is no hot key to enable or
disable it.  There are several reasons for this:

1.  Leaving out Hot key support keeps the code very small -- about
    1K.

2.  If you really needed to disable it, you could use Mark/Release.

3.  I wanted this code to be a teaching example.  I did not want
    to have any more complications that necessary.


Please report bugs and problems to:

Roedy Green
Canadian Mind Products
#208 - 525 Ninth Street
New Westminster BC Canada
V5H 2N6
tel:(604) 777-1804
mailto:roedy@mindprod.com
http://mindprod.com

Version History
***************

version 2.2 1998 November 8
- embed Barker address

Version 2.1 1996 October 25
- embed POB 707 Quathiaski Cove address

Espan 2.0 1993 June 8
        - embed new address and phone.
        - bypassed 1.6 so that version can be encoded in the timestamp.

Espan 1.5 was released to BIX on 1991 Nov 20
        - fix bug, part of translate table was being overwritten
          by the list of accents.

Espan 1.4 was released to BIX on 1991 Sept 2
        - bug in BuildChar routine, generated garbage scan code but
          correct character.  AGustafsson on BIX detected the bug.
        - code to bypass bug in WordPerfect Office
          AGustafsson on BIX detected the problem and provide the
          solution.  He used Espan to create a Norwegian keyboard
          handler.

Espan 1.3 was released to BIX on 1991 July 24 for beta test.

What Espan is for
******************

Espan lets use use the traditional Spanish keyboard layout.  It
is also a skeleton program to write your own compact keyboard
remapping routines.

The foreign language support routines that come with DOS take up
too much RAM.  There is no support for the standard Spanish layout.

What Espan Has to Do
********************

Espan must handle the following problems:

1.  Some keys are in a different location.  This could be handled by
    a simple scan code translation, but we use a more general method.

2.  Some symbols are paired on the keys in unusual ways.  For example
    <> are paired together on a single key rather than as ,< and .> in
    US keyboards.

3.  The accent key [ has gets unusual treatment.  If you hit it, the next
    vowel gets an accent applied.  If you hit it twice in a row, it is
    treated as simple [.  If you hit Shift-{ you get {.  The accent key
    also works on C to give C cedille.

4.  In future, Espan might also handle the Alt-Gr key (the right Alt key).
    Some keys might have three legends.  Hitting Alt-Gr simultaneously
    would get the third alternative.

5.  If Alt or Ctrl is pressed, we may just want BIOS to do the processing.

6.  If the keyboard buffer is full, it must make a short, shrill beep.

7.  Espan has been designed to fairly easily add extra accent keys
    so that you can get all the accented letters.



BIOS Tools Espan Can Use
************************

For the AT we leave a small TSR resident that intercepts the INT
15 4F keyboard remap interrupt that gets triggered by hardware
every time there is a keystroke event (down or up).

The scan code appears in AL and we can change it if we want.  If
we "consume" the scan code, and with BIOS to do no further
processing on it, we can clear the carry flag, otherwise we
leave it set.

In the XT this extended INT 16 feature may or may not be
present.  If not you must load KEYB US first to provide the
extended INT 16 features.

We get both key-press and key-release scan codes.  We can
ignore key-releases.

Int 16 function 05 PUSH CHARACTER AND SCAN CODE allows us to
push a scan code / character pair into the keystroke buffer.
This is our method of generating characters for which there is
no corresponding scan code. In theory this function is supposed
to set the carry bit, and set AL=01 if the function fails.
However some BIOSes fail to set carry.

We sometimes need to know the state of CapLock or the Shift key
in order to decide whether to generate an upper or lower case
character.  We can find this out using INT 16H function 02, GET
KEYBOARD FLAGS.  Note this function does not let us discriminate
left from right ALT key.

Keyboard intercept fine points
******************************

Consider int 15H function 4Fh keyboard intercept.

Int 15 used for many things.  If you want to intercept
characters, you must enchain yourself to the old vector value,
so at the very least you can let the old vector handle non-4F
functions.

However, what if you DO process a character?  You are supposed
to Clear carry to indicate consumption and set carry to indicate
BIOS should handle the scan code.  Let us say we process a char.
Should we or should we not AFTERWARD, jump to the old vector?

If we have CONSUMED the character, we should NOT jump, we should
return immediately to avoid confusing downstream filters.  They
are expecting carry set.  They would not not how to handle a
consumed character.

If we have NOT consumed the char, we should jump to the old
vector to let other filters have a bash at it.

Since the keyboard handler invokes INT 15H 4F with an INT, on the
stack will be the pushed the flags, then CS: then IP.  You are
supposed to clear carry to indicate you have consumed a
character.  Just doing a CLC will not suffice, since the IRET
will just restore the original flags buried on the stack.  You
have to clear carry, then do a RETF 2, to get rid of the buried
flags.

How Espan Works
***************

The most important table is the classifier table that classifies
each incoming scan code.  We strip the high bit before using it,
so it needs to be only 128 characters long.

There are six classes of keypress scan code:

0 - ignore this key entirely (there are no such keys in this implementation).
1 - ordinary key that BIOS can handle, turns off accenting though.
2 - ordinary key that BIOS can handle, but allows accent to stay on.
3 - Key like "8/*" where determination based on state of SHIFT key.
4 - Key like "A" where determination based on state of SHIFT/Capslock.
5 - the [ key - the key that turns on the accent.

The class is then used to index one of six routines to handle the code.

Class 1 - PLAIN control scan codes, leave alone.
-  this code could also be used to handle perfectly
   standard alphabetic keys that do not participate in
   special processing.
 - Pass the translated scan code through to BIOS for processing.
-  Turn off Accent-Pending.
-  Tell BIOS to continue processing the scan code.

Class 2 - as class 1 but has no effect on accent-pending.
 - e.g. shift is not supposed to turn of the pending accent.
 - Just pass translated scan code through to BIOS for processing.

Class 3 - SHIFT SENSITIVE
 - test state of Ctrl and Alt keys.
   If pressed treat like class 1.
 - test state of shift key
   If pressed use Upper case translate table to find corresponding
   character otherwise use the Lower case translate table.
   If Accent-Pending, apply the appropriate accent.
   Push the translated character, and translated scan code into the keystroke buffer.
   If the buffer is full, emit a short beep.
   Turn off Accent-Pending.
   Tell BIOS keystroke was consumed.

Class 4 - CAPSLOCK SENSITIVE
 - test state combined Capslock and shift keys
   Treat as per class 2.

Class 5 - THE ACCENT KEY
 - test state of shift key.
   If pressed Push a { into the keystroke buffer.
   If not pressed
        test Accent-Pending
           if not on already turn on Accent-Pending.
           if already on push a [ into the keystroke buffer and
              turn off Accent-Pending.
   Tell BIOS keystroke was consumed.

We thus need 4 translate tables -- each 128 bytes long, indexed
by scan code with the high bit stripped.

Classifier      - class of treatment for the scan code
NewScan         - new translated scan code.
LowerCase       - ascii code this generates lower case
UpperCase       - ascii code this generates upper case

There are also some small tables 16 bytes long giving both the
lower and upper case forms of the characters that could
potentially have accents.

Unaccented gives the unaccented forms.
Spanish give the Spanish accented forms.
Aigu gives the acute accented forms etc.

The Espan Layout
*****************

 Esc     F1  F2  F3  F4  F5  F6  F7  F8  F9  F10  F11  F12


>         #   $   %   /   &   *   (   )  ---  +   |  Bsp
<   1   2   3   4   5   6   7   8   9   0   -   =   \

  Tab  Q   W   E   R   T   Y   U   I   O   P   {   }
       q   w   e   r   t   y   u   i   o   p   [   ]

CapsLock A   S   D   F   G   H   J   K   L      :   Ent
         a   s   d   f   g   h   j   k   l      ;

      Shf  Z   X   C   V   B   N   M   ?   !   "  Shf
           z   x   c   v   b   n   m   ,   .   '

Ctrl  Alt                  Space                    Alt-Gr   Ctrl

Accented letters are a e i o u -- upper or lower case
                         
                     A  I O U

Accent key is [ which adds an acute accent to the next vowel.
[ [ gives [.  Shift-[ gives {

The following keys have no direct representation:

There is currently no direct support for the following:
@ ascii 64  - at sign
 ascii 170 - PL/I not sign, upper right corner symbol
 ascii 248 - raised circle
^ ascii 94  - circonflex
` ascii 96  - grave
 ascii 166 - a bar (I think this means something like nth in English)
 ascii 167 - o bar

There are no Alt-Gr keys.


The original QWERTY Layout
**************************

 Esc     F1  F2  F3  F4  F5  F6  F7  F8  F9  F10  F11  F12


~   !   @   #   $   %   ^   @   *   (   )  ---  +   |  Bsp
`   1   2   3   4   5   6   7   8   9   0   -   =   \

  Tab  Q   W   E   R   T   Y   U   I   O   P   {   }
       q   w   e   r   t   y   u   i   o   p   [   ]

CapsLock A   S   D   F   G   H   J   K   L   :   "   Ent
         a   s   d   f   g   h   j   k   l   ;   '

      Shf  Z   X   C   V   B   N   M   <   >   ?  Shf
           z   x   c   v   b   n   m   ,   .   /

Ctrl  Alt                  Space                     Alt   Ctrl

Feel free to modify the translate table to better fit the
eccentricities of your keyboard.

Register conventions
********************

During the interrupt, be must be careful to put everything, even
the flags back the way they were.  The two exceptions are the
carry flag and AL -- containing the scan code.

At the beginning of interrupt proceessing we save BX and CX.  We
set up DS:.  These are restored on exit.  During processing we
may trash these registers and AH.  However we must be extremely
careful to restore any other register used such as ES: and DI.

We keep the scan code in AL throughout the processing.

 ; end of comment

CODE    SEGMENT PARA

        ASSUME  CS:CODE,DS:CODE
        ORG     100H

;==============================================================

; Configuration EQUATES


;==============================================================

;       Register Conventions
;
;       All subroutines are permitted to trash whatever registers
;       they like.  It is the caller's responsibility to save
;       and restore registers.  For speed, callers cheat and only
;       save registers they know the called program changes.
;       In a few cases, subroutines do save/restore some registers.

;==============================================================

SAY     MACRO   Msg
;;      display message on screen
        lea     dx,&Msg         ;; use LEA rather than
                                ;; MOV Offset for more generality
        mov     ah,09h          ;; some assemblers will optimise this.
        int     21h
        ENDM

;==============================================================

KEY     MACRO   scan,ns,class,lc,uc
        ORG     CLASSIFIER+&Scan        ;; build 3 translate tables
        db      &Class*2                ;; class 0 .. 10
                                        ;; mult by 2 to index by words
        ORG     NewSCAN+&Scan
        db      &ns                     ;; new scan code

        ORG     LCTRT+&Scan
        db      &lc                     ;; lower case

        ORG     UCTRT+&Scan
        db      &uc                     ;; upper case

        ENDM

;==============================================================

; MAINLINE PROGRAM

Espan    PROC    FAR
START:
        JMP     Init
                                ; Mainline disposable Init routine
                                ; uses TRAP to set up vectors to
                                ; FIELD which later
                                ; does the real work.

;==============================================================

; VARIABLES


RealInt15Off    DW      0       ; offset of original INT15 BIOS code
                                ; More likely will be pointer to
                                ; entry point of some other TSR
                                ; already hooked onto INT 15.
RealInt15Seg    DW      0       ; Seg of original INT15 BIOS code

AccentPending   DW      0       ; 0 if no Accent key just pressed.
                                ; address of table of appropriate accents
                                ; otherwise, eg. Spanish or Trema

;==============================================================

FIELD   Proc    Far
;       Field (intercept and handle) INT 15 Interrupt
                                ; at this point on stack is
                                ; flags, CS: IP of code in INT 9 keystroke
                                ; Interrupts are off.  EOI not yet issued
                                ; cld/std state unknown.
                                ; probably AH=4F AL=scan carry set.
                                ; interrupt handler than invoked us with INT 15
                                ; We use caller's SS:SP as a stack.
        pushf
        cmp     AH,04Fh         ; check if this is function 4F
        jne     NotStroke       ; 4F is the peek at keystroke interrupt
        test    al,80h
        jnz     notStroke       ; we do no processing on release strokes

IsStroke:
;   Is a downstroke.  Figure out what class.
        push    bx              ; save a few registers
        push    cx
        push    DS
        mov     bx,CS
        mov     DS,bx           ; set up DS to cover
        sub     bh,bh           ; classify the scan code
        mov     bl,al
        mov     bl,classifier[bx]
        Jmp     word ptr HandleClass[BX]
                                ; jump to routine to process that class
                                ; of character.
                                ; will return to either
                                ; LetBiosProcessStroke or
                                ; ConsumeStroke
LetBiosProcessStroke:
        pop     DS
        pop     cx
        pop     bx              ; ask BIOS to continue processing this
                                ; scan code, following popf will restore
                                ; STC set by INT 9
        mov     ah,4Fh          ; restore ah, just in case.

NotStroke:

;       Fall through to let other INT 15 AF handlers have a crack.
                                ; We simply want to jump to
                                ; the original INT 15,
        popf                    ; or give any other INT 15 AF handlers a bash
                                ; at the character as well.
                                ; will restore carry set.
        jmp     cs: dword ptr [RealInt15Off]

ConsumeStroke:
        pop     DS              ; tell BIOS we have handled the stroke and
        pop     cx              ; it need not process it further.
        pop     bx
        mov     ah,4Fh          ; restore ah, just in case.
        popf                    ; restore flags
        clc                     ; tell BIOS stroke is consumed.
        retf    2               ; bypass restoring buring flags that would
                                ; occur if we used IRET
                                ; DON'T confuse downstream handlers
                                ; with the consumed keystroke;
                                ; we do not enchain to old vector.

FIELD   EndP

;==============================================================

HandleClass     label word
        ; table of routines to handle each class of scan code
        dw offset       Class0          ; ignore
        dw offset       Class1          ; via BIOS
        dw offset       Class2          ; via BIOS, but no effect on accent
        dw offset       Class3          ; shift sensitive
        dw offset       Class4          ; capslock sensitive
        dw offset       Class5          ; turn on Spanish accents next char
                                        ; If more accents supported, this
                                        ; table would have to be expanded.

comment        ; following not needed for pure spanish version

        dw offset       Class6          ; Aigu acute
        dw offset       Class7          ; Grave
        dw offset       Class8          ; Trema diaeresis
        dw offset       Class9          ; Circonflexe hat
        dw offset       Class10         ; Ring

comment        ; above not needed for pure spanish version

;==============================================================

Class0  Proc    Near
;       ret handle a class 0 scan code -- ignore the stroke
        jmp     ConsumeStroke

Class0  EndP

;==============================================================

Class1  Proc    Near
;       ret handle a class 1 scan code -- let BIOS handle it
;       Turns off AccentPending though.
        mov     AccentPending,0
        lea     bx,NewScan      ; translate old to new scan code
        xlat                    ; al = [bx+al] to get new scan code
        jmp     LetBiosProcessStroke

Class1  EndP

;==============================================================

Class2  Proc    Near
;       ret handle a class 1 scan code -- let BIOS handle it
;       No effect on accentPending, e.g. Like Shift.
        lea     bx,NewScan      ; translate old to new scan code
        xlat                    ; al = [bx+al] to get new scan code
        jmp     LetBiosProcessStroke

Class2  EndP

;==============================================================

Class3  Proc    Near
;       ret handle a class 3 scan code, shift state sensitive
;       ax is scan code
        mov     bl,al           ; save copy of al
        mov     ah,02H          ; get keyboard flags
        int     16H
        xchg    al,bl
                                ; al=scan code bl=kbd flags
        test    bl,0Ch          ; test if Ctrl or Alt pressed
        jnz     Class1          ; if yes, let BIOS handle it
                                ; but turn off AccentPending
        test    bl,3h           ; test if either shift key is down
                                ; nz means upper case, z mean lower case
        jmp     BuildChar       ; never return

Class3  EndP

;==============================================================

AccentOn        Proc    Near

;       Turn on accents on next char.  This char ignored usually.
;       Comments done in terms of Spanish accents, but could be any
;       accent
;       On entry BX points to table of accented letters e.g. Spanish

        push    ax
        mov     ah,02H          ; get keyboard flags
        int     16H
        test    al,03h          ; test if either shift key is down
        pop     ax
        jnz     Class3          ; if shiftkey, treat { like ordinary
                                ; key needing uc conversion
        test    AccentPending,-1
        jnz     Class3          ; if on already, treat like [ needing
                                ; ordinary lc conversion
        mov     AccentPending,bx
                                ; turn on AccentPending
                                ; apply the Spanish accents next
        jmp     ConsumeStroke

AccentOn        EndP

;==============================================================

Class4  Proc    Near
;       ret handle a class 4 scan code, CapsLock Sensitive
;       ax is scan code
;       upper case is XOR of Shift and Capslock state.
;       i.e. if they differ, we are in upper case.

        mov     bl,al           ; save copy of al, the scan code
        mov     ah,02H          ; get keyboard flags
        int     16H
        xchg    al,bl           ; al=scan code bl=kbd flags
        test    bl,0Ch          ; test if Ctrl or Alt pressed
        jnz     Class1          ; if yes, let BIOS handle it
        test    bl,3h           ; test if either shift key is down
        lahf
        test    bl,40h          ; test if capslock is on
        mov     bl,ah
        lahf
        xor     bl,ah           ; test if shift key state diff capslock
        test    bl,40h          ; look at just the z flag
                                ; if nz means differ means upper case
        jmp     BuildChar       ; never return

Class4  EndP

;==============================================================

Class5  Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke Spanish accents with the [ key
        lea     bx,Spanish
        jmp     AccentOn

Class5  EndP

;==============================================================

comment        ; following not needed for pure spanish version

Class6  Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke acute accents with the some key
        lea     bx,Aigu
        jmp     AccentOn

Class6  EndP

;==============================================================

Class7  Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke grave accents with some key
        lea     bx,Grave
        jmp     AccentOn

Class7  EndP

;==============================================================

Class8  Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke Trema diaeresis accents with some key
        lea     bx,Trema
        jmp     AccentOn

Class8  EndP

;==============================================================

Class9  Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke Circonflexe accents with some key
        lea     bx,Circ
        jmp     AccentOn

Class9  EndP

;==============================================================

Class10 Proc    Near

;       ret handle a class 5 scan code -- the accent key itself
;       Invoke Ring accents with the some
        lea     bx,Ring
        jmp     AccentOn

Class10 EndP

comment        ; above not needed for pure spanish version

;==============================================================

BuildChar Proc  near

;       handle bulk of work for class 3 and class 4 scan codes
;       On entry flag reg says whether to use lc or uc table
;       nz = uc  z = lc
;       al is the scan code

        lea     bx,LCTRT        ; presume will use lower case
        jz      StillLCTRT
        lea     bx,UCTRT        ; use UC Trt instead
StillLCTRT:
                                ; bx contains address of TRT for char
        mov     cl,al           ; CH = old scan code
        xlat                    ; translate al = [bx+al] to get char
        test    AccentPending,-1
        jz      NoAccentNeeded
        call    ApplyAccent
NoAccentNeeded:
        xchg    cl,al           ; CL = char, AL=old scan code
        lea     bx,NewScan      ; translate old to new scan code
        xlat                    ; al = [bx+al] to get new scan code
        mov     ch,al           ; CH = new scan code
        mov     ah,05h          ; push char/scan to keystroke buffer
        int     16h             ; CH = scan code CL = char
                                ; either carry set or al=1 means trouble
                                ; WordPerfect Office ALWAYS sets carry
                                ; so we do not rely on this as a sign
                                ; of failure.
;;      jc      PushFail
        cmp     al,01
        jne     PushSuccessful
PushFail:
                                ; buffer overflow.  Emit a short beep
        call    Beep
PushSuccessful:
        mov     AccentPending,0 ; turn off AccentPending
        jmp     ConsumeStroke   ; Tell BIOS not to bother with further
                                ; stroke processing.

BuildChar EndP

;==============================================================

ApplyAccent     Proc    Near

;       on entry al contains char needing an accent (poss lc or uc).
;       AccentPending points to table of accented chars for that accent,
;       e.g. Spanish
;       On exit, al contains the accented char.
;       Works by scanning list of unaccented chars that could potentially
;       have accent the translates to corresponding char in accent table.

        push    ES
        push    di
        push    bx
        push    cx
        mov     bx,CS
        mov     ES,bx
        assume  ES:CODE
        lea     di,Unaccented   ; get list of lc then uc chars
        mov     cx,16d          ; count of chars in lc/uc list
        cld                     ; in interrupt, cannot count on CLD
        repne   scasb           ; search for match
        jne     NothingtoAccent ; usually will be no match
                                ; match di, is pointing one past
        sub     di,offset Unaccented+1
                                ; get offset relative to start of table
        mov     bx,AccentPending; start of table of corresp accented chars
        mov     al,[bx+di]      ; get corresp accented char
NothingToAccent:
        assume  ES:nothing
        pop     cx
        pop     bx
        pop     di
        pop     ES
        ret

ApplyAccent     EndP

;==============================================================

Divisor equ     270             ; divisor for freq 4186 Hz, 3 octaves above mid C
Dur     equ     16666           ; mics duration (1/16 sec)

;==============================================================

BEEP    Proc    Near            ; emit one short beep
        sti                     ; turn ints back on, this will take a while
        push    ax
        Call    SoundOn
        push    ax              ; save old sound port value
        Call    Delay
        pop     ax
        Call    SoundOff
        pop     ax
        ret

BEEP    ENDP

;==============================================================

SoundOn Proc    Near
;       Turn on the speaker, hide old setting in AH
;       AH must remain undisturbed for soundoff.

        mov     al,0b6h
        out     043h,al         ; write timer mode register
        mov     ax,Divisor      ; freq divisor
                                ; two octaves above middle A.
        out     042h,al         ; write timer 2 cnt - lsb
        mov     al,ah
        out     042h,al         ; write timer 2 cnt - msb
        in      al,061h         ; get current port b setting
        mov     ah,al           ; save current setting
        or      al,003h         ; turn speaker on
        out     061h,al
        ret

SoundOn EndP

;==============================================================

Delay   Proc    Near
;       Delay   Dur microseconds
;       does not work on Compaq when called inside keyboard interrupt

        push    ax
        push    cx
        push    dx
        mov     cx,0            ; MSW
        mov     dx,Dur          ; LSW
        mov     ah,86h          ; delay CX:DX microseconds
        int     15h
        pop     dx
        pop     cx
        pop     ax
        ret

Delay   EndP

;==============================================================

SoundOff Proc   Near
;       Turn off the speaker
;       old port value in AH

        mov     al,ah           ; recover value of port
        out     061H,al
        ret

SoundOff EndP

;==============================================================

;       E Q U A T E S   F O R   S C A N   C O D E S   B Y   N A M E
;
;       We use SYSTEM scan codes, not keyboard scan codes.
;       INT 15 will see codes after the keyboard controller has
;       translated them.
;       Upper and lower case A use the same scan code as do 1 and ! for example.
;       When a key is duplicated on the numeric keypad and on the arrow
;       keypad, both use the same code, but the arrow keypad gets an E0 prefix.
;       This is a very simple minded translate program.  It does not look for
;       E0 characters.  It does the same translation for both the prefixed and
;       plain characters.
;       The E0 characters themselves get passed through unmolested.
;       The press down codes shown have the high bit off.  The release
;       codes are the same with the high bit on.

_ESC    EQU     01h     ; Esc
_1      EQU     02h     ; 1 !
_2      EQU     03h     ; 2 @
_3      EQU     04h     ; 3 #
_4      EQU     05h     ; 4 $
_5      EQU     06h     ; 5 %
_6      EQU     07h     ; 6 ^
_7      EQU     08h     ; 7 &
_8      EQU     09h     ; 8 *
_9      EQU     0Ah     ; 9 (
_0      EQU     0Bh     ; 0 )
_Minus  EQU     0Ch     ; - _
_Eq     EQU     0Dh     ; = +
_BS     EQU     0Eh     ; backspace <-
_Tab    EQU     0Fh     ; Tab ->
_Q      EQU     10h     ; Q
_W      EQU     11h     ; W
_E      EQU     12h     ; E
_R      EQU     13h     ; R
_T      EQU     14h     ; T
_Y      EQU     15h     ; Y
_U      EQU     16h     ; U
_I      EQU     17h     ; I
_O      EQU     18h     ; O
_P      EQU     19h     ; P
_LSq    EQU     1Ah     ; [ {
_RSq    EQU     1Bh     ; ] }
_Enter  EQU     1Ch     ; Enter
_Ctrl   EQU     1Dh     ; Ctrl (left or right)
_A      EQU     1Eh     ; A
_S      EQU     1Fh     ; S
_D      EQU     20h     ; D
_F      EQU     21h     ; F
_G      EQU     22h     ; G
_H      EQU     23h     ; H
_J      EQU     24h     ; J
_K      EQU     25h     ; K
_L      EQU     26h     ; L
_Semi   EQU     27h     ; ; :
_Quote  EQU     28h     ; ' "
_Grave  EQU     29h     ; ` ~
_LShift EQU     2Ah     ; Left Shift
_BSlash EQU     2Bh     ; \ |
_Z      EQU     2Ch     ; Z
_X      EQU     2Dh     ; X
_C      EQU     2Eh     ; C
_V      EQU     2Fh     ; V
_B      EQU     30h     ; B
_N      EQU     31h     ; N
_M      EQU     32h     ; M
_Comma  EQU     33h     ; , <
_Period EQU     34h     ; . >
_Slash  EQU     35h     ; / ?
_RShift EQU     36h     ; Right Shift
_PrtSc  EQU     37h     ; PrintScreen
_Alt    EQU     38h     ; left Alt, Right alt uses same code with E0 prefix
_Space  EQU     39h     ; Space
_CapsLk EQU     3Ah     ; CapsLock
_F1     EQU     3Bh     ; function key F1
_F2     EQU     3Ch     ; function key F2
_F3     EQU     3Dh     ; function key F3
_F4     EQU     3Eh     ; function key F4
_F5     EQU     3Fh     ; function key F5
_F6     EQU     40h     ; function key F6
_F7     EQU     41h     ; function key F7
_F8     EQU     42h     ; function key F8
_F9     EQU     43h     ; function key F9
_F10    EQU     44h     ; function key F10
_NumLk  EQU     45h     ; NumLock
_ScLk   EQU     46h     ; ScrollLock
_Home   EQU     47h     ; Home 7
_UP     EQU     48h     ; ^ arrow 8
_PgUp   EQU     49h     ; PgUp 9
_PadMin EQU     4Ah     ; Keypad minus
_Left   EQU     4Bh     ; <- 4
_Pad5   EQU     4Ch     ; 5 on keypad
_Right  EQU     4Dh     ; -> 6
_PadPls EQU     4Eh     ; Keypad plus
_End    EQU     4Fh     ; End 1
_Down   EQU     50h     ; v arrow 2
_PgDn   EQU     51h     ; PgDn 3
_Ins    EQU     52h     ; Ins 0
_Del    EQU     53h     ; Del .
_Sys    EQU     54h     ; SysRequest
_F11    EQU     57h     ; function key 11 (not always present)
_F12    EQU     58h     ; function key 12 (not always present)
; pause button simultates a Ctrl-Numlock.
;
; You can use the PC PowerTools utility, SCAN, to find out what codes your
; keyboard is generating.  To stop SCAN, hit the space bar.
; You may have to adjust the above table slightly.
;
;==============================================================

;       The four translate tables
CLASSIFIER      LABEL BYTE
        ;       class of each scan code
        db      128 dup (1*2)
                ; store as *2 so that can index word table of handlers
                ; 0 = ignore completely
                ; 1 = let BIOS handle, but clear Accent
                ; 2 = let BIOS handle, no effect on Accent state (e.g. Shift)
                ; 3 = SHIFT sensitive key needing translation
                ; 4 = CAPSLOCK sensitive key needing translation or accent
                ; 5 = Invoke Spanish accents on next key
                ; 6 = Invoke Aigu acute accent on next key
                ; 7 = Invoke Grave accent on next key
                ; 8 = Invoke Trma  accent on next key
                ; 9 = Invoke Circonflex accent on next key
                ;10 = Invoke Ring accent on next key

NewScan label   Byte            ; new scan code.  By default stays same
        Count = 0
        REPT    128d
        db      Count
        Count = Count + 1
        ENDM

LCTRT   db      128 dup (0)
                ; character to translate scan into if in lower case

UCTRT   db      128 dup (0)
                ; character to translate scan into if in upper case


EndTrt  Label   Byte
;=================================================================
; <><><><><><><><><><><><><><><><><>
; These override the four previous translate table defaults.
;
;  You may leave out any keys that will be treated as on as standard USA keyboard.
;  If the character is potentially accentable, you must include it here explicitly.
;               scan    NewScan class   lc  uc

        KEY     _1,     _1,     3,      "1",""
        KEY     _2,     _2,     3,      "2",""
        KEY     _6,     _6,     3,      "6","/"
        KEY     _E,     _E,     4,      "e","E"
        KEY     _U,     _U,     4,      "u","U"
        KEY     _I,     _I,     4,      "i","I"
        KEY     _O,     _O,     4,      "o","O"
        KEY     _LSq,   _LSq,   5,      "[","{"
        KEY     _RSq,   _RSq,   3,      "]","}"
        KEY     _A      _A,     4,      "a","A"
        KEY     _Semi   _Semi,  3,      "",""
        KEY     _Quote  _Semi,  3,      ";",":"
        KEY     _Grave  _Comma, 3,      "<",">"
        KEY     _C      _C,     4,      "c","C"
        KEY     _Comma  _Comma, 3,      ",","?"
        KEY     _Period _Period,3,      ".","!"
        KEY     _Slash  _Quote, 3,      "'",'"'
        KEY     _LShift _LShift,2,      0,0
        KEY     _RShift _RShift,2,      0,0
        KEY     _Alt    _Alt,   2,      0,0

        ORG     EndTrt  ; get to the end

;=================================================================

Unaccented      db      "aceinouy"      ; unaccented, template chars to help
                db      "ACEINOUY"      ; find matching accented chars

Spanish         db      "y"      ; general Spanish accents
                db      "AIOUY"

comment        ; following not needed for pure spanish version


Aigu            db      "y"      ; Aigu - acute accent
                db      "AIOUY"

Grave           db      "y"      ; grave accent
                db      "AEIOUY"

Trema           db      ""      ; diaeresis - Trma
                db      "EIY"

Circ            db      "y"      ; circonflexe
                db      "AEIOUY"

Ring            db      "eiouy"      ; ring, general Swedish accents
                db      "EIOUY"

comment        ; above not needed for pure spanish version


;==============================================================
;==============================================================
;==============================================================
;==============================================================
;==============================================================
; Everything below this line is disposable initialization code.
; It is thrown away and is not part of the resident code.
;==============================================================
;==============================================================
;==============================================================
;==============================================================
;==============================================================
DISPOSE:
;==============================================================
Init    Proc    Near
;       Intialize Espan then Terminate and Stay Resident
        Say     CopyRightMsg    ; CopyRight banner
        call    Trap            ; redirect INT15 vector
        call    TSR             ; exit to DOS
Init    EndP

;==============================================================

TRAP    Proc    Near
;                               ; redirect the INT 15 to FIELD
;       Save real Int 15 vector
        mov     ax,3515h        ; get vector for multiplex int 15
        int     21h             ; vector in ES:BX
        mov     RealInt15Seg,ES ; save real vector
        mov     RealInt15Off,BX
;       Set up our Int 15 vector
                                ; DS:DX is vector.  DS ok already.
        mov     dx,Offset Field
        mov     ax,2515h        ; set vector for mulitplex int 15
        int     21h             ; set vector from DS:DX
        ret
Trap    EndP

;==============================================================

TSR     Proc    Near
;       Terminate and Stay Resident

        mov     ES,DS:[2Ch]     ; pointer to environment
        mov     ah,49h          ; free ram allocated to the SET enviroment
        int     21h

        MOV     AH,3Eh          ; Close StdIn
        MOV     BX,0            ; Avoid holding onto a handle if
        INT     21H             ; foolish user typed Espan <Myfile

        MOV     AH,3Eh          ; Close StdOut
        MOV     BX,1            ; Avoid holding onto a handle if
        INT     21H             ; user typed Espan >NUL:

        MOV     AX,3100H        ; Terminate and Stay Resident function
                                ; Exit to DOS
        MOV     DX,((Dispose-Start)+100h+15d)/16d
        INT     21h             ; paragraphs to keep resident
                                ; 100h accounts for PSP.
                                ; 15d rounds up to next para.
                                ; We can throw away all
                                ; initialization code.
TSR     EndP

;==============================================================

;       Disposable Variables

;==============================================================

; Messages are all disposable, needed only during initialization.

CopyRightMsg    LABEL BYTE
        DB      ' Espan 2.2 ۲',13,10
        DB      13,10
        DB      'Translate keyboard to Spanish layout',13,10
        DB      13,10
        DB      'Copyright (c) 1991-1999 Roedy Green',13,10
        DB      'Canadian Mind Products',13,10
        DB      '#208 - 525 Ninth Street, New Westminster, BC Canada V3M 5T9',13,10
        DB      'tel:(604) 777-1804   mailto:roedy@mindprod.com   http://mindprod.com',13,10
        DB      'This program may be freely copied and used for any purpose except military.',13,10,'$'

;==============================================================

Espan   ENDP
CODE    ENDS
        END     START
